package com.supervision.constant;

import lombok.Getter;

@Getter
public enum JudgeResultEnum {

    TRUE("1","真实"),

    FALSE("2","虚构"),

    EXIST("3","存在"),

    NOT_EXIST("4","不存在"),

    UNKNOWN("5","未知");

    private String code;
    private String desc;

    JudgeResultEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }

    /**
     * 根据code获取枚举
     * @param code 标识
     * @return
     */
    public static JudgeResultEnum getInstance(String code) {
        for (JudgeResultEnum judgeResultEnum : JudgeResultEnum.values()) {
            if (judgeResultEnum.getCode().equals(code)) {
                return judgeResultEnum;
            }
        }
        return null;
    }

    /**
     * 判断是否为真
     * @return
     */
    public boolean flagIsTrue() {
        return this.code.equals("1") || this.code.equals("3");
    }

}
