package com.supervision.police.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.supervision.police.domain.SystemMenu;
import com.supervision.police.dto.MenuDTO;
import com.supervision.police.service.SystemMenuService;
import com.supervision.police.mapper.SystemMenuMapper;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
* @author Administrator
* @description 针对表【system_menu(菜单表)】的数据库操作Service实现
* @createDate 2024-07-31 11:02:43
*/
@Service
public class SystemMenuServiceImpl extends ServiceImpl<SystemMenuMapper, SystemMenu>
    implements SystemMenuService{

    @Override
    public List<MenuDTO> listMenu() {

        List<SystemMenu> systemMenuList = super.list();
        if (CollUtil.isEmpty(systemMenuList)){
            return new ArrayList<>();
        }

        List<MenuDTO> menuDTOList = systemMenuList.stream().map(MenuDTO::new).toList();
        for (MenuDTO menuDTO : menuDTOList) {
            List<MenuDTO> children = menuDTOList.stream()
                    .filter(item -> menuDTO.getId().equals(item.getParentId())).toList();
            menuDTO.setChildren(children);
        }
        return menuDTOList.stream().filter(item -> StrUtil.isEmpty(item.getParentId())).toList();
    }
}




